/*
 * This file is part of the SOAFaces Project (hereinafter "SOAFaces").
 * Copyright (C) 2006 Grand Logic, Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */


package org.soafaces.bundle.client.rpc.impl;

import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.IsSerializable;
import java.util.Map;

/**
 * @author Sam Taha
 */
public interface BundleDataAccessRPCAsync {

  void getTaskletStatus(long jobid, long runid, long taskid, AsyncCallback callback);
  void getAppCookie(long jobid, long taskid, AsyncCallback callback);
  void setAppCookie(long jobid, long taskid, Map<String,String> editMap, AsyncCallback callback);

  void getInputBeanPOJO(long jobid, long taskid, String stTaskPackageName, long effDate, AsyncCallback callback);
  void getInputBeanJSON(long jobid, long taskid, String stTaskPackageName, long effDate, AsyncCallback callback);
  
  void getInputBeanRuntimePOJO(long jobid, long runid, long taskid, String stTaskPackageName, AsyncCallback callback);
  void getInputBeanRuntimeJSON(long jobid, long runid, long taskid, String stTaskPackageName, AsyncCallback callback);
  
  void getOutputBeanRuntimePOJO(long jobid, long runid, long taskid, String stTaskPackageName, AsyncCallback callback);
  void getOutputBeanRuntimeJSON(long jobid, long runid, long taskid, String stTaskPackageName, AsyncCallback callback);
  
  void setInputBeanPOJO(long jobid, long taskid, boolean bIsApp, IsSerializable bean, String stTaskPackageName, long effDate, AsyncCallback callback);
  void setInputBeanJSON(long jobid, long taskid, boolean bIsApp, String jsonBean, String stTaskPackageName, long effDate, AsyncCallback callback);
  
  void cacheTmpInputBeanPOJO(long jobid, long taskid, IsSerializable bean, AsyncCallback callback);
  void cacheTmpInputBeanJSON(long jobid, long taskid, String jsonBean, AsyncCallback callback);
}
